"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fail = exports.finish = exports.step_ = exports.step = void 0;
/**
 * Creates a Step.
 * @typeparam A - Type of step results.
 * @param x - Value to use.
 * @returns A LoopAction.
 */
function step(x) {
    return { action: 'step', value: x };
}
exports.step = step;
/**
 * Creates a Step with null value.
 * @returns A LoopAction.
 */
function step_() {
    return { action: 'step', value: null };
}
exports.step_ = step_;
/**
 * Creates a Finish.
 * @typeparam B - Type of finish results.
 * @param x - Value to use.
 * @returns A LoopAction.
 */
function finish(x) {
    return { action: 'finish', value: x };
}
exports.finish = finish;
/**
 * Creates a Fail.
 * @typeparam E - Type of errors.
 * @param x - Value to use.
 * @returns A LoopAction.
 */
function fail(x) {
    return { action: 'fail', error: x };
}
exports.fail = fail;
//# sourceMappingURL=loopAction.js.map