import { UnorderedStrategy } from './unordered';
import { Token } from './tokens';
import { ParserOutput } from './parserOutput';
/**
 * Parses a list of tokens to separate out flags and options.
 */
export declare class Parser implements IterableIterator<ParserOutput> {
    private readonly input;
    private unorderedStrategy;
    private position;
    /**
     * @param input - The input tokens.
     */
    constructor(input: Token[]);
    /**
     * Sets the strategy for parsing unordered arguments.
     * This can be done in the middle of parsing.
     */
    setUnorderedStrategy(s: UnorderedStrategy): this;
    /**
     * Whether the parser is finished.
     */
    get finished(): boolean;
    private shift;
    /**
     * Gets the next parsed tokens.
     */
    next(): IteratorResult<ParserOutput>;
    private processToken;
    private pFlag;
    private pOption;
    private pCompactOption;
    private pOrdered;
    [Symbol.iterator](): this;
    /**
     * Runs the parser.
     */
    parse(): ParserOutput;
}
